/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.fleet.parser.config;

import java.io.FileNotFoundException;
import java.io.FileInputStream;

import com.sunlabs.archsim.fleet.nameTable.SourceDestinationNameTable;;

/**
 * A facade for the generated parser for Fleet configuration files.
 * This class exists for safety and convenience - 
 * instead of handling exceptions in
 * the .jj input file for JavaCC, we do it here and get the benefits of
 * IDE and the benefits of an explicitly defined interface.
 * 
 * @author ib27688
 *
 */
public class ConfigParser {
	
	public ConfigParser() {
		
	}
	
	public void parse(String fileName) 
	throws FileNotFoundException, ParseException {
	
		FileInputStream inStream= null;

		// FileNotFound exception thrown if a file does not exist
		inStream= new FileInputStream(fileName);
		
		// we have a file reader, now make a parser and get a table
		ParseConfig parser= new ParseConfig(inStream);
		// Now do the parsing
		// ParseException thrown if there is an error
		parser.Symbols(SourceDestinationNameTable.getInstance());
	}
	
} // ConfigParser
